from tweepy import Stream
from tweepy import OAuthHandler
from tweepy.streaming import StreamListener
import time
import json
import sys
import datetime

non_bmp_map = dict.fromkeys(range(0x10000, sys.maxunicode + 1), 0xfffd)

#fill in bellow your consumer key, consumer secret, access token, access secret
#see https://developer.twitter.com/en/docs/basics/developer-portal/overview 
#on how to obtain them
ckey=""
csecret=""
atoken=""
asecret=""

class listener(StreamListener):

    def on_data(self, data):
        all_data = json.loads(data)
        try:
            tweet = all_data["text"]
        except:
            return
        username = all_data["user"]["screen_name"]
        if (True):
            #print content
            print("-"*80)
            print (datetime.datetime.now())
            print("User:"+username)
            print("Tweet:"+tweet.translate(non_bmp_map)) #for screen output
        s=""
        for hashtag in all_data["entities"]["hashtags"]:
            s=s+" #"+hashtag["text"].upper()
        print("Hashtags:"+s)
        return(True)

    def on_error(self, status):
        print(status)

auth = OAuthHandler(ckey, csecret)
auth.set_access_token(atoken, asecret)

twitterStream = Stream(auth, listener())
#pass keywords as arguments to this script
#e.g. ./twitter.py nba bucks
args=sys.argv
args.pop(0)
print("Looking for the following keywords:",args)
twitterStream.filter(track=args)
